#include "StdAfx.h"
#include "IniFile.h"
#include "GlobalData.h"
#include "General.h"

#define	ROOT_PATH		"c:\\MMA-G"
#define	DATA_PATH		"\\data"
#define	NAME_INI		"MMA_G.ini"

#define	SEC_PATH		"PATH"
#define	KEY_ROOT_PATH	"ROOT_PATH"
#define	KEY_REAL_TIME_DATA_PATH	"REALTIME_DATA_PATH"
#define	KEY_REAL_TIME_TEMP_PATH	"REALTIME_TEMP_PATH"
#define	KEY_DOWNLINK_REFERENCE_PATH	"DOWNLINK_REFERENCE_PATH"
#define KEY_AUTO_CONV_PATH "AUTO_CONV_PATH"

#define	SEC_TOOL		"TOOL"
#define	KEY_EXE_PATH	"EXE_PATH"

#define	SEC_LAUNCH		"LAUNCH"
#define	KEY_LAUNCH_TIME	"LAUNCH_TIME"

#define SEC_SETTING		"SETTING"
#define KEY_ZERO_OFFSET_SW	"ZERO_OFFSET_SW"
#define KEY_SPECTRUM_PSD_RANGE	"SPECTRUM_PSD_RANGE"
#define KEY_ZERO_OFFSET_SPAN	"ZERO_OFFSET_SPAN"
#define KEY_REALTIME_RANGE	"REALTIME_RANGE"

#define SEC_CHOICE		"CHOICE"
#define KEY_CHOICE_CATEGORY	"CATEGORY"
#define KEY_CHOICE_MEASUREMENT_KIND	"MEASUREMENT_KIND"

// init@C̏擾
bool CIniFile::Read(void)
{
	CString	iniName;

	// NꂽAvP[ṼtpX擾
	SetExeDir();
	iniName = gExePath;
	iniName += '\\';
	iniName += NAME_INI;

	// f[^i[tH_擾
	GetPrivateProfileString(
		SEC_PATH,			// ZNV
		KEY_ROOT_PATH,		// L[
		ROOT_PATH,			// ̕
		gRootPath,			// 񂪊i[obt@
		sizeof(gRootPath),	// obt@̃TCY
		(LPCSTR)iniName		// .init@C
	);

	// Z~RłȂ̃pX𕪉
	int nPos= 0;
	CString sRootPath = gRootPath;
	CString sToken = sRootPath.Tokenize(";", nPos);
	while (sToken != "") {
		sToken = sToken.TrimRight('\\');
		if (gRootDataList.GetSize() == 0)
			strcpy_s(gRootPath, sToken);
		gRootDataList.Add(sToken + DATA_PATH);
		sToken = sRootPath.Tokenize(";", nPos);
	}

	// Hwlf[^i[tH_ҏW
	strcpy_s(gRootData, gRootPath);
	strcat_s(gRootData, DATA_PATH);

	// c[EXE擾
	GetPrivateProfileString(
		SEC_TOOL,					// ZNV
		KEY_EXE_PATH,				// L[
		"",							// ̕
		gToolExe,					// 񂪊i[obt@
		sizeof(gToolExe),			// obt@̃TCY
		iniName						// .init@C
	);

	// LaunchTime擾
	GetPrivateProfileString(
		SEC_LAUNCH,					// ZNV
		KEY_LAUNCH_TIME,			// L[
		"YYYY_MM_DD_hh_mm_ss.ttt",	// ̕
		gLaunchTime,				// 񂪊i[obt@
		sizeof(gLaunchTime),		// obt@̃TCY
		iniName						// .init@C
	);

	// A^Cf[^pX擾
	GetPrivateProfileString(
		SEC_PATH,					// ZNV
		KEY_REAL_TIME_DATA_PATH,	// L[
		"",							// ̕
		gRealtimeDataPath,			// 񂪊i[obt@
		sizeof(gRealtimeDataPath),	// obt@̃TCY
		iniName						// .init@C
	);

	// A^Ce|pX擾
	GetPrivateProfileString(
		SEC_PATH,					// ZNV
		KEY_REAL_TIME_TEMP_PATH,	// L[
		"",							// ̕
		gRealtimeTempPath,			// 񂪊i[obt@
		sizeof(gRealtimeTempPath),	// obt@̃TCY
		iniName						// .init@C
	);

	// _ENtH_QƃpX擾
	GetPrivateProfileString(
		SEC_PATH,						// ZNV
		KEY_DOWNLINK_REFERENCE_PATH,	// L[
		"",								// ̕
		gDownlinkReferencePath,			// 񂪊i[obt@
		sizeof(gDownlinkReferencePath),	// obt@̃TCY
		iniName							// .init@C
	);

	// 0_␳LftHgl擾
	char tZeroOffsetSw[256];
	GetPrivateProfileString(
		SEC_SETTING,					// ZNV
		KEY_ZERO_OFFSET_SW,				// L[
		"",								// ̕
		tZeroOffsetSw,					// 񂪊i[obt@
		sizeof(tZeroOffsetSw),			// obt@̃TCY
		iniName							// .init@C
	);
	gZeroOffsetSw = (_stricmp(tZeroOffsetSw, "ON") == 0);

	// XyNgPSD͈̓ftHgl擾
	char tSpectrumPsdRange[256];
	GetPrivateProfileString(
		SEC_SETTING,					// ZNV
		KEY_SPECTRUM_PSD_RANGE,			// L[
		"0",							// ̕
		tSpectrumPsdRange,				// 񂪊i[obt@
		sizeof(tSpectrumPsdRange),		// obt@̃TCY
		iniName							// .init@C
	);
	gSpectrumPsdRange = atof(tSpectrumPsdRange);

	// 0_␳lOtԊԊu擾
	gZeroOffsetSpan = GetPrivateProfileInt(
		SEC_SETTING,					// ZNV
		KEY_ZERO_OFFSET_SPAN,			// L[
		3600,							// ̐l
		iniName							// .init@C
	);

	// HwlϊtH_pX擾
	GetPrivateProfileString(
		SEC_PATH,						// ZNV
		KEY_AUTO_CONV_PATH,				// L[
		"",								// ̕
		gAutoConvPath,					// 񂪊i[obt@
		sizeof(gAutoConvPath),			// obt@̃TCY
		iniName							// .init@C
	);

	// A^C\͈
	gRealtimeRange = GetPrivateProfileInt(
		SEC_SETTING,					// ZNV
		KEY_REALTIME_RANGE,				// L[
		60,								// ̐l
		iniName							// .init@C
	);

	// JeSI擾
	char tChoiceCategory[1024];
	GetPrivateProfileString(
		SEC_CHOICE,						// ZNV
		KEY_CHOICE_CATEGORY,			// L[
		"",								// ̕
		tChoiceCategory,				// 񂪊i[obt@
		sizeof(tChoiceCategory),		// obt@̃TCY
		iniName							// .init@C
	);
	CGeneral::StrSplit(tChoiceCategory, ";", gChoiceCategory);

	// vޑI擾
	char tChoiceMeasurementKind[1024];
	GetPrivateProfileString(
		SEC_CHOICE,						// ZNV
		KEY_CHOICE_MEASUREMENT_KIND,	// L[
		"",								// ̕
		tChoiceMeasurementKind,			// 񂪊i[obt@
		sizeof(tChoiceMeasurementKind),	// obt@̃TCY
		iniName							// .init@C
	);
	CGeneral::StrSplit(tChoiceMeasurementKind, ";", gChoiceMeasurementKind);

	return true;
}

// NꂽAvP[ṼtpX擾
void CIniFile::SetExeDir(void)
{
	TCHAR szFull[_MAX_PATH];    // NꂽAvP[ṼtpX
	TCHAR szDrive[_MAX_DRIVE];  // NꂽAvP[ṼhCu
	TCHAR szDir[_MAX_DIR];      // NꂽAvP[ṼfBNg

	memset(szFull, 0, sizeof(szFull));
	memset(szDrive, 0, sizeof(szDrive));
	memset(szDir, 0, sizeof(szDir));

	// NꂽAvP[ṼtpX擾
	::GetModuleFileName(NULL, szFull, sizeof(szFull) / sizeof(TCHAR));
	// tpXhCufBNgɕ
	_splitpath_s(szFull, szDrive, sizeof(szDrive)
		, szDir, sizeof(szDir)
		, NULL, 0, NULL, 0);
	// hCuƃfBNgA
	_makepath_s(gExePath, szDrive, szDir, NULL, NULL);
	int len;
	if ((len = (int)strlen(gExePath)) != 0) {
		if (gExePath[len - 1] == '\\')
			gExePath[len - 1] = 0;
	}
}
